﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Text;
using System.Web.UI.WebControls;
/// <summary>
/// This class is used to generate script for handling generate items e.g tags
/// </summary>
public class UGeneral
{
	public UGeneral()
	{
		//
		// TODO: Add constructor logic here
		//
	}

    // this function used to generate single tag item
    public string Generate_Tag_Item(string tagname, int records, int type, string cssclass, bool maintag)
    {
        StringBuilder str = new StringBuilder();
        string _item_type = "videos";
        switch (type)
        {
            case 0:
                _item_type = "videos";
                break;
            case 1:
                _item_type = "groups";
                break;
            case 2:
                _item_type = "photos";
                break;
            case 3:
                _item_type = "blog posts";
                break;
            case 4:
                _item_type = "audio";
                break;
            case 5:
                _item_type = "photos";
                break;
        }
        string tag_url = UrlConfig.Prepare_Tag_Url(tagname, type, maintag);
        string tag_url_style = "";
        if (records <= 9)
            tag_url_style = "style=\"font-size: 100%;\"";
        else if (records >= 10 && records <= 19)
            tag_url_style = "style=\"font-size: 108%;\"";
        else if (records >= 20 && records <= 39)
            tag_url_style = "style=\"font-size: 116%;\"";
        else if (records >= 40 && records <= 69)
            tag_url_style = "style=\"font-size: 131%;\"";
        else if (records >= 70 && records <= 99)
            tag_url_style = "style=\"font-size: 138%;\"";
        else if (records >= 100 && records <= 149)
            tag_url_style = "style=\"font-size: 146%;\"";
        else if (records >= 150 && records <= 399)
            tag_url_style = "style=\"font-size: 161%;\"";
        else if (records >= 400)
            tag_url_style = "style=\"font-size: 171%;\"";

        string css_class = "";
        if (cssclass != "")
            css_class = "class=\"" + cssclass + "\"";
        str.Append("<a href=\"" + tag_url + "\" " + css_class + " " + tag_url_style + " title=\"" + tagname + " " + _item_type + "\">" + tagname + "</a>");
        return str.ToString();
    }
      
    // Utility script to return list of selected values in list box item
    public static string ReturnSelectedCategories(ListControl cat)
    {
        int i = 0;
        StringBuilder str = new StringBuilder();

        for (i = 0; i <= cat.Items.Count - 1; i++)
        {
            if (cat.Items[i].Selected && cat.SelectedIndex > 0)
            {
                if (str.ToString() == "")
                    str.Append(cat.Items[i].Value);
                else
                    str.Append("," + cat.Items[i].Value);
            }
        }

        return str.ToString();
    }

    // Select Multiple Categories within list box control
    public static void SelectMultipleItems(ListControl cat, string categories)
    {
        if (categories.Contains(","))
        {
            string[] arr = categories.ToString().Split(char.Parse(","));
            int i;
            for (i = 0; i <= arr.Length - 1; i++)
            {
                string value = arr[i].ToString();
                if (value != "")
                {
                    int j = 0;
                    for (j = 0; j <= cat.Items.Count - 1; j++)
                    {
                        if (cat.Items[j].Value == value)
                            cat.Items[j].Selected = true;
                    }
                }

            }
        }
        else
        {
            string value = categories;
            if (value != "")
            {
                int j = 0;
                for (j = 0; j <= cat.Items.Count - 1; j++)
                {
                    if (cat.Items[j].Value == value)
                        cat.Items[j].Selected = true;
                }
            }
        }

    }

    // ***************************************************
    // CORE LAYOUT FUNCTIONS
    // ***************************************************
    public string Return_Navigation_Class()
    {
        string cssClass = "chnl_left";
        switch (Site_Settings.NavigationSection)
        {
            case 0:
                // left side navigation
                // two column layout
                cssClass = "chnl_left";
                break;
            case 1:
                // right side navigation
                // two column layout
                cssClass = "chnl_right_nav";
                break;
            case 2:
                // two side navigation (left and right) - content in center
                // three column layout
                cssClass = "bd_left";
                break;
        }
        return cssClass;
    }

    public string Return_Body_Class()
    {
        string cssClass = "chnl_right";
        switch (Site_Settings.NavigationSection)
        {
            case 0:
                // left side navigation
                // two column layout
                cssClass = "chnl_right";
                break;
            case 1:
                // right side navigation
                // two column layout
                cssClass = "chnl_left_mn";
                break;
            case 2:
                // two side navigation (left and right) - content in center
                // three column layout
                cssClass = "bd_main";
                break;
        }
        return cssClass;
    }

    public string Return_RightNav_Class()
    {
        // only appear in three column layout
        string cssClass = "";
        switch (Site_Settings.NavigationSection)
        {
            case 0:
                // left side navigation
                // two column layout
                cssClass = "";
                break;
            case 1:
                // right side navigation
                // two column layout
                cssClass = "";
                break;
            case 2:
                // two side navigation (left and right) - content in center
                // three column layout
                cssClass = "bd_right";
                break;
        }
        return cssClass;
     }
    //****************************************************
    // CORE THEME FUNCTIONS
    //****************************************************
    public static string Return_Box_Css(int template)
    {
        int selected_template = 0;
        if (template > 0) // force template
            selected_template = template;
        else
        {
            if (Site_Settings.Site_Templates != 100)
                selected_template = Site_Settings.Site_Templates; // choose admin selected template if 100 is choosen
            else
            {
                // if admin choose default
                if (Site_Settings.NavigationSection == 2 && Site_Settings.Site_Templates == 0)
                {
                    // its not supported
                    // three column and web 2.0 style
                    selected_template = 2;
                }
                else
                    selected_template = template;
            }
        }
        string cssClass = "";
        if(selected_template ==0)
            cssClass = "module ui-corner-all";
        else
            cssClass = "module_pd2 ui-corner-all";

        return cssClass;
    }

     public static string Return_Heading_Css(int template)
    {
        int selected_template = 0;
        if (template > 0) // force template
            selected_template = template;
        else
        {
            if (Site_Settings.Site_Templates != 100)
                selected_template = Site_Settings.Site_Templates; // choose admin selected template if 100 is choosen
            else
            {
                // if admin choose default
                if (Site_Settings.NavigationSection == 2 && Site_Settings.Site_Templates == 0)
                {
                    // its not supported
                    // three column and web 2.0 style
                    selected_template = 2;
                }
                else
                    selected_template = template;
            }
        }
        string cssClass = "";
        switch (selected_template)
        {
            case 0:
                // Default web 2.0 style clean
               cssClass = "heading";
                break;
            case 1:
                // jquery ui header style
                cssClass = "heading-round btn-primary";
                break;
            case 2:
                // jquery ui default state style
                cssClass = "heading-round btn-warning";
                break;
            case 3:
                // jquery ui default hover style
                cssClass = "heading-round btn-danger";
                break;
            case 4:
                // jquery ui default active style
                cssClass = "heading-round btn-inverse";
                break;
        }
        return cssClass;
    }
    //****************************************************
    // GENERAL UTILITY FUNCTIONS
    //****************************************************

    // Utility function to prepare description of any record
     public static string Prepare_Description(string description, int length)
     {  
         string desc = UtilityBLL.CompressCode(description);
         if (desc == "")
             return desc;

         if (desc.Length > length && length > 0)
             desc = desc.Substring(0, length) + "..";
         
         return desc;
     }

    // utility function to prepare one or more category links for any record
     public static string Prepare_Categories(string categories, int length, string cssclass, int type)
     {
         // type : type of category (e.g 0: video, 5: photo etc)
         // length: maximum characters allowed

         string output = "";
         string cat = "";
         if (categories != "")
         {           
             if (categories.Contains(","))
             {
                 if (categories.Length > length && length > 0)
                 {
                     categories = categories.Substring(0, length);
                     categories = categories.Remove(categories.LastIndexOf(","));
                 }
                 StringBuilder catstr = new StringBuilder();
                 string[] arr = categories.ToString().Split(char.Parse(","));
                 int i = 0;
                 for (i = 0; i <= arr.Length - 1; i++)
                 {
                     if (arr[i].ToString().Length > 3)
                     {
                         if (i > 0)
                             catstr.Append(", ");
                         catstr.Append("<a class=\"" + cssclass + "\" href=\"" + UrlConfig.Prepare_Category_Url(0, arr[i].ToString(), "", type, true) + "\" title=\"" + arr[i].ToString() + "\">" + arr[i].ToString().Trim() + "</a>");
                     }
                 }
                 output = catstr.ToString();
             }
             else
             {
                 cat = categories;
                 if (cat.Length > length && length > 0)
                     cat = cat.Substring(0, length) + "..";
                 output = "<a class=\"" + cssclass + "\" href=\"" + UrlConfig.Prepare_Category_Url(0, categories, "", type, true) + "\" title=\"" + categories + "\">" + cat.Trim() + "</a>";
             }
         }
         return output;
     }

     // utility function to prepare one or more tag links for any record
     public static string Prepare_Tags(string tags, int length, string cssclass, int type)
     {
         // type : type of category (e.g 0: video, 5: photo etc)
         // length: maximum characters allowed
         string output = "";
         string cat = "";
         if (tags != "")
         {
             if (tags.Contains(","))
             {
                 if (tags.Length > length && length > 0)
                 {
                     tags = tags.Substring(0, length);
                     tags = tags.Remove(tags.LastIndexOf(","));
                 }
                 StringBuilder catstr = new StringBuilder();
                 string[] arr = tags.ToString().Split(char.Parse(","));
                 int i = 0;
                 for (i = 0; i <= arr.Length - 1; i++)
                 {
                     if (arr[i].ToString().Length > 3)
                     {
                         if (i > 0)
                             catstr.Append(", ");
                         catstr.Append("<a class=\"" + cssclass + "\" href=\"" + UrlConfig.Prepare_Tag_Url(arr[i].ToString(), type, true) + "\" title=\"" + arr[i].ToString() + "\">" + arr[i].ToString().Trim() + "</a>");
                     }
                 }
                 output = catstr.ToString();
             }
             else
             {
                 cat = tags;
                 if (cat.Length > length && length > 0)
                     cat = cat.Substring(0, length) + "..";
                 output = "<a class=\"" + cssclass + "\" href=\"" + UrlConfig.Prepare_Tag_Url(tags, type, true) + "\" title=\"" + tags + "\">" + cat.Trim() + "</a>";
             }
         }
         return output;
     }


     #region Video Thumb Processing Script
     // Main function used to process core video thumb stored on local server, remote server, cloud storage or third party storage e.g youtube video thumbs
     public static string ProcessVideoThumb(int width, int height, string url, Video_Struct vd, bool isaudio)
     {
         // media thumb section
         StringBuilder str = new StringBuilder();
         StringBuilder img_str = new StringBuilder();
         img_str.Append("<a class=\"thumbnail\" style=\"width:" + width + "px; height:" + height + "px;\" href=\"" + url + "\" title=\"" + vd.Title + "\">"); // thumb link setup
         if (isaudio)
         {
             // audio thumb setup
             // default thumb preview is used for audio, you can change with your own requirements.
             vd.Thumb_Url = Config.GetUrl() + "images/no-audio.jpg";
             str.Append(Process_Embed_Video_Thumb(img_str, vd.Thumb_Url, width, height));
         }
         else
         {
             if (vd.isExternal == 0)
             {
                 if (vd.isPublished == 0 || vd.ErrorCode > 0 || vd.ThumbFileName == "" || vd.ThumbFileName == "none")
                 {
                     // video is not yet published
                     // or published failed - any level of error raised
                     // or thumbfilename is empty
                     vd.Thumb_Url = Config.GetUrl() + "images/vd_thumb.png";
                     str.Append(Process_Embed_Video_Thumb(img_str, vd.Thumb_Url, width, height));
                 }
                 else
                 {
                     // normal video upload
                     str.Append(Process_Normal_Video_Thumb(img_str, vd.UserName, vd.ThumbFileName, vd.Thumb_Url, width, height));
                 }
             }
             else if (vd.isExternal == 1)
             {
                 // embed video upload
                 str.Append(Process_Embed_Video_Thumb(img_str, vd.Thumb_Url, width, height));
             }
             else if (vd.isExternal == 2)
             {
                 // process both embed and upload thumb
                 if (vd.Embed_Script != "")
                     str.Append(Process_Embed_Video_Thumb(img_str, vd.Thumb_Url, width, height));
                 else
                 {
                     if (vd.isPublished == 0 || vd.ErrorCode > 0 || vd.ThumbFileName == "" || vd.ThumbFileName == "none")
                     {
                         // video is not yet published
                         // or published failed - any level of error raised
                         // or thumbfilename is empty
                         vd.Thumb_Url = Config.GetUrl() + "images/vd_thumb.png";
                         str.Append(Process_Embed_Video_Thumb(img_str, vd.Thumb_Url, width, height));
                     }
                     else
                     {
                         str.Append(Process_Normal_Video_Thumb(img_str, vd.UserName, vd.ThumbFileName, vd.Thumb_Url, width, height));
                     }
                 }
             }
         }
         return str.ToString();
     }

     private static string Process_Embed_Video_Thumb(StringBuilder img_str, string thumburl, int width, int height)
     {        
         img_str.Append("<img src=\"" + thumburl + "\" style=\"width:" + width + "px;height:" + height + "px;\" />\n");
         img_str.Append("</a>");
         return img_str.ToString();
     }

     private static string Process_Normal_Video_Thumb(StringBuilder img_str, string username, string mediapath, string thumburl, int width, int height)
     {
         // video thumbnail processing
         string MediaName = mediapath;
         if (MediaName.Contains("_"))
         {
             string thumb_start_index = MediaName.Remove(MediaName.LastIndexOf("_"));
             string _thumb_url = Config.Return_Video_Thumb_Url(thumburl, username);
             string thumb_start_sequence_path = "";
             string imagepath = "";
             if (thumburl == "" || thumburl == "none")
             {
                 // default thumb fetching
                 thumb_start_sequence_path = _thumb_url + "/" + thumb_start_index + "_";
                 imagepath = _thumb_url + "/" + MediaName;
             }
             else
             {
                 // cloud thumb fetching
                 if (_thumb_url.Contains("_"))
                     thumb_start_sequence_path = _thumb_url.Remove(_thumb_url.LastIndexOf("_")) + "_";
                 imagepath = _thumb_url;
             }

            
            // single thumb
            img_str.Append("<img src=\"" + imagepath + "\" style=\"height:" + height + "px; width:" + width + "px;\" />");
            img_str.Append("</a>");
 
         }
         return img_str.ToString();
     }

     // Generate thumb rotator script for each video item
     public static string Generate_Thumb_Rotator_Script(string thumbfilename)
     {
         StringBuilder str = new StringBuilder();
         string thumb_start_index = "";
         if (thumbfilename.Contains("_"))
             thumb_start_index = thumbfilename.Remove(thumbfilename.LastIndexOf("_"));
         str.Append("stat['" + thumb_start_index + "']=0;");
         str.Append("pic['" + thumb_start_index + "']=new Array();");
         str.Append("pics['" + thumb_start_index + "']=new Array(0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);");
         return str.ToString();
     }
     #endregion
}