﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Collections.Generic;

public partial class adm_sc_videos_Default : System.Web.UI.Page
{

    private VideoBLL _mediadalc = new VideoBLL();
    public int Mode = 0;
    protected string _script;

    public long AlbumID
    {
        get
        {
            if (ViewState["AlbumID"] != null)
                return (long)ViewState["AlbumID"];
            else
                return 0;
        }
        set
        {
            ViewState["AlbumID"] = value;
        }
    }

    public int PageNumber
    {
        get
        {
            if (ViewState["PageNumber"] != null)
                return (int)ViewState["PageNumber"];
            else
                return 1;
        }
        set
        {
            ViewState["PageNumber"] = value;
        }
    }

    public string UserName
    {
        get
        {
            if (ViewState["UserName"] != null)
                return ViewState["UserName"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["UserName"] = value;
        }
    }

    public int TotalRecords
    {
        get
        {
            if (ViewState["TotalRecords"] != null)
                return (int)ViewState["TotalRecords"];
            else
                return 0;
        }
        set
        {
            ViewState["TotalRecords"] = value;
        }
    }

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        rptPages.ItemCommand += this.rptPages_ItemCommand;

    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            // Check whether admin section is in readonly mode.
            if (!Config.isAdminActionAllowed())
            {
                Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
                return;
            }
            
            // set actions
            if (Request.Params["user"] != null)
            {
                UserName = Request.Params["user"].ToString();
                src.Visible = false; // disable search panel.
            }
            if (Request.Params["f"] != null)
                drp_filter.SelectedValue = Request.Params["f"].ToString();
            if (Request.Params["t"] != null)
                drp_isenable.SelectedValue = Request.Params["t"].ToString();
            if (Request.Params["r"] != null)
                drp_isreviewed.SelectedValue = Request.Params["r"].ToString();
            if (Request.Params["mdp"] != null)
                drp_mtype.SelectedValue = Request.Params["mdp"].ToString();
            if (Request.Params["albumid"] != null)
                this.AlbumID = Convert.ToInt64(Request.Params["albumid"]);
            if (Request.Params["featured"] != null)
                drp_featured.SelectedValue = Request.Params["featured"].ToString();
            if (Request.Params["adult"] != null)
                drp_isadult.SelectedValue = Request.Params["adult"].ToString();
            if (Request.Params["embed"] != null)
                drp_isexternal.SelectedValue = Request.Params["embed"].ToString();
            
            if (Request.Params["status"] != null)
            {
                switch (Request.Params["status"].ToString())
                {
                    case "deleted":
                        Config.ShowMessageV2(msg, "Video has been deleted successfully", "Success!", 1);
                        break;
                    case "viduploaded":
                        Config.ShowMessageV2(msg, "Video has been uploaded and published successfully", "Success!", 1);
                        break;
                    case "vidpending":
                        Config.ShowMessageV2(msg, "Video has been uploaded and pending for publishing", "Success!", 1);
                        break;
                }
            }

            int category_type = 0; // represent videos
            if (Site_Settings.AllowMultipleCategoryListing)
            {
                // Multiple category selection is on
                CategoriesBLL.BindCategories(l_category, 0, category_type, " All Categories ", "", false);
                scat.Visible = false;
            }
            else
            {
                // Single category selection is on
                // load parent / child categories
                CategoriesBLL.BindCategories(drp_categories, 0, category_type, " All Categories ", "", false);
                mcat.Visible = false;
            }

             BindList();
        }
    }
       
    
    private void BindList()
    {

        int pagesize = Convert.ToInt32(drp_pagesize.SelectedValue);
        string search = "";
        if (txt_search.Text != "")
            search = txt_search.Text;
        // process categories
        string _categories = "";
        // categories enabled
        if (Site_Settings.AllowMultipleCategoryListing)
            _categories = UGeneral.ReturnSelectedCategories(l_category);
        else
            _categories = drp_categories.SelectedValue;

        this.TotalRecords = VideoBLL.Count_Videos(search, this.UserName, "", _categories, Convert.ToInt32(drp_isenable.SelectedValue), Convert.ToInt32(drp_iscomments.SelectedValue), Convert.ToInt32(drp_isreviewed.SelectedValue), Convert.ToInt32(drp_isadult.SelectedValue), Convert.ToInt32(drp_featured.SelectedValue), Convert.ToInt32(drp_isprivate.SelectedValue), Convert.ToInt32(drp_mtype.SelectedValue), Convert.ToInt32(drp_isexternal.SelectedValue), Convert.ToInt32(drp_filter.SelectedValue), this.Mode, this.AlbumID);
        if (this.TotalRecords == 0)
        {
            // no record exist
            pnl_main.Visible = false;
            pnl_norecord.Visible = true;
            lbl_records.Text = "0 records found";
            return;
        }

        List<Video_Struct> list = VideoBLL.Load_Videos(search, this.UserName, "", _categories, Convert.ToInt32(drp_isenable.SelectedValue), Convert.ToInt32(drp_iscomments.SelectedValue), Convert.ToInt32(drp_isreviewed.SelectedValue), Convert.ToInt32(drp_isadult.SelectedValue), Convert.ToInt32(drp_featured.SelectedValue), Convert.ToInt32(drp_isprivate.SelectedValue), Convert.ToInt32(drp_mtype.SelectedValue), Convert.ToInt32(drp_isexternal.SelectedValue), Convert.ToInt32(drp_filter.SelectedValue), drp_order.SelectedValue, this.PageNumber, pagesize, this.Mode, this.AlbumID);
        if (list.Count > 0)
        {
            ViewState["script_value"] = "";
            //int count = int.Parse(list.Count.ToString());
            if (this.TotalRecords > 1)
                lbl_records.Text = this.TotalRecords + " records found";
            else
                lbl_records.Text = this.TotalRecords + " record found";
            // setup pagination
            Pagination_Process.Process_Pagination(MyList, rptPages, lnk_Prev, lnk_Next, pagesize, this.PageNumber, list, this.TotalRecords);
      
            pnl_main.Visible = true;
            pnl_norecord.Visible = false;
            _script = "<script type=\"text/javascript\">" + ViewState["script_value"].ToString() + "</script>";
        }
        else
        {
            pnl_main.Visible = false;
            pnl_norecord.Visible = true;
            lbl_records.Text = "0 records found";

        }
    }


    protected void MyList_ItemDataBound(object sender, DataListItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            // set video | audio item
            modules_item_videoitem _itm = (modules_item_videoitem)e.Item.FindControl("Videoitem1");
            _itm.VD = (Video_Struct)e.Item.DataItem;
            _itm.MediaType = Convert.ToInt32(drp_mtype.SelectedValue);
            _itm.ContentLayout = 1;
            _itm.BoxWidth = 500;
            _itm.LeftWidth = 30;
            _itm.RightWidth = 69;
            _itm.isAdmin = true;

            string MediaName = ((Label)e.Item.FindControl("lbl_mediapath")).Text;
            //// process and generate thumb changer script
            string thumb_start_index = "";
            if (MediaName.Contains("_"))
                thumb_start_index = MediaName.Remove(MediaName.LastIndexOf("_"));

            string str = "";
            str = str + "stat['" + thumb_start_index + "']=0;";
            str = str + "pic['" + thumb_start_index + "']=new Array();";
            str = str + "pics['" + thumb_start_index + "']=new Array(0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);";
            ViewState["script_value"] = ViewState["script_value"] + str;

            // Action section
            int isenabled = int.Parse(((Label)e.Item.FindControl("lbl_isenabled")).Text);
            int isreviewed = int.Parse(((Label)e.Item.FindControl("lbl_isreviewed")).Text);
            Label lbl_action = (Label)e.Item.FindControl("lbl_action");

            if (isenabled == 1 && isreviewed == 1)
            {
                lbl_action.Text = "Available";
                lbl_action.CssClass = "mini-text green bold";
            }
            else
            {
                lbl_action.Text = "Blocked";
                lbl_action.CssClass = "mini-text red bold";
            }

        }
    }


    protected void rptPages_ItemCommand(object source, RepeaterCommandEventArgs e)
    {
        LinkButton btnPage = (LinkButton)e.Item.FindControl("btnPage");
        PageNumber = int.Parse(btnPage.Text);
        BindList();
    }


    protected void rptPages_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            LinkButton btnPage = (LinkButton)e.Item.FindControl("btnPage");
            if (int.Parse(btnPage.Text) == PageNumber)
            {
                btnPage.CssClass = "btn btn-danger btn-mini";
            }
            else
            {
                btnPage.CssClass = "btn btn-primary btn-mini";
            }
        }
    }

    protected void lnk_Next_Click(object sender, EventArgs e)
    {
        PageNumber = PageNumber + 1;
        BindList();
    }
    protected void lnk_Prev_Click(object sender, EventArgs e)
    {
        PageNumber = PageNumber - 1;
        BindList();
    }
         
    protected void btn_submit_Click(object sender, EventArgs e)
    {
        this.PageNumber = 1;
        BindList();
    }

    protected void btn_approve_Click(object sender, EventArgs e)
    {
        UpdateApproved(1);
    }
    protected void btn_disable_Click(object sender, EventArgs e)
    {
        UpdateDisabled(0);
    }
    protected void btn_delete_Click(object sender, EventArgs e)
    {
        Delete();
    }
   

    protected void btn_enabled_Click(object sender, EventArgs e)
    {
        UpdateDisabled(1);
    }
   

    protected void btn_adult_Click(object sender, EventArgs e)
    {
        UpdateAdult(1);
    }
    protected void btn_nonadult_Click(object sender, EventArgs e)
    {
        UpdateAdult(0);
    }
    protected void btn_featured_Click(object sender, EventArgs e)
    {
        UpdateFeatured(1);
    }
    protected void btn_normal_Click(object sender, EventArgs e)
    {
        UpdateFeatured(0);
    }
    protected void btn_premium_Click(object sender, EventArgs e)
    {
        UpdateFeatured(3); // 3: Premium Videos
    }

    protected void Delete()
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect(Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        int index;
        bool flg = false;
        for (index = 0; index < MyList.Items.Count; index++)
        {
            CheckBox select_chk;
            select_chk = (CheckBox)MyList.Items[index].FindControl("chk_inbox");
            if (select_chk.Checked)
            {
                long vid = Convert.ToInt64(((Label)MyList.Items[index].FindControl("lbl_vid")).Text);
                string username = ((Label)MyList.Items[index].FindControl("lbl_user")).Text;
                VideoBLL.Delete(vid, username, 1);
               
                if (flg == false)
                    flg = true;
            }

        }
        if (flg == false)
            Config.ShowMessageV2(msg, "please select record", "Info!", 2);
        else
            Config.ShowMessageV2(msg, "selected records have been deleted successfully", "Success!", 1);

        BindList();
    }

    protected void UpdateDisabled(int status)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect(Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        int index;
        bool flg = false;
        for (index = 0; index < MyList.Items.Count; index++)
        {
            CheckBox select_chk;
            select_chk = (CheckBox)MyList.Items[index].FindControl("chk_inbox");
            if (select_chk.Checked)
            {
                long vid = Convert.ToInt64(((Label)MyList.Items[index].FindControl("lbl_vid")).Text);
                string username = ((Label)MyList.Items[index].FindControl("lbl_user")).Text;
                int OldValue = Convert.ToInt32(VideoBLL.Get_Field_Value(vid, "isenabled"));
                VideoBLL.Update_IsEnabled(vid, OldValue, status, username, 0);
                
                if (flg == false)
                    flg = true;
            }

        }
        if (flg == false)
            Config.ShowMessageV2(msg, "please select record", "Info!", 2);
        else
        {
            if(status==1)
                Config.ShowMessageV2(msg, "selected records have been enabled successfully", "Success!", 1);
            else
                Config.ShowMessageV2(msg, "selected records have been disabled successfully", "Success!", 1);
        }

        BindList();
    }

    protected void UpdateApproved(int status)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect(Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        int index;
        bool flg = false;
        for (index = 0; index < MyList.Items.Count; index++)
        {
            CheckBox select_chk;
            select_chk = (CheckBox)MyList.Items[index].FindControl("chk_inbox");
            if (select_chk.Checked)
            {
                long vid = Convert.ToInt64(((Label)MyList.Items[index].FindControl("lbl_vid")).Text);
                string username = ((Label)MyList.Items[index].FindControl("lbl_user")).Text;
                int OldValue = Convert.ToInt32(VideoBLL.Get_Field_Value(vid, "isreviewed"));
                VideoBLL.Update_IsReviewed(vid,OldValue, status, username, 0);
                
                if (flg == false)
                    flg = true;
            }

        }
        if (flg == false)
            Config.ShowMessageV2(msg, "please select record", "Info!", 2);
        else
        {
            if (status == 1)
                Config.ShowMessageV2(msg, "selected records have been approved successfully", "Success!", 1);
            else
                Config.ShowMessageV2(msg, "selected records have been dis approved successfully", "Success!", 1);
        }

        BindList();
    }

    protected void UpdateAdult(int status)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect(Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        int index;
        bool flg = false;
        for (index = 0; index < MyList.Items.Count; index++)
        {
            CheckBox select_chk;
            select_chk = (CheckBox)MyList.Items[index].FindControl("chk_inbox");
            if (select_chk.Checked)
            {
                long vid = Convert.ToInt64(((Label)MyList.Items[index].FindControl("lbl_vid")).Text);
                string username = ((Label)MyList.Items[index].FindControl("lbl_user")).Text;
                VideoBLL.Update_Field(vid, status.ToString(), "isadult");
                if (flg == false)
                    flg = true;
            }

        }
        if (flg == false)
            Config.ShowMessageV2(msg, "please select record", "Info!", 2);
        else
        {
            if (status == 1)
                Config.ShowMessageV2(msg, "selected records have been marked as adult successfully", "Success!", 1);
            else
                Config.ShowMessageV2(msg, "selected records have been marked as non adult successfully", "Success!", 1);
        }

        BindList();
    }

    protected void UpdateFeatured(int status)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect(Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        int index;
        bool flg = false;
        for (index = 0; index < MyList.Items.Count; index++)
        {
            CheckBox select_chk;
            select_chk = (CheckBox)MyList.Items[index].FindControl("chk_inbox");
            if (select_chk.Checked)
            {
                long vid = Convert.ToInt64(((Label)MyList.Items[index].FindControl("lbl_vid")).Text);
                string username = ((Label)MyList.Items[index].FindControl("lbl_user")).Text;
                VideoBLL.Update_Field(vid, status.ToString(), "isfeatured");

                if (flg == false)
                    flg = true;
            }

        }
        if (flg == false)
            Config.ShowMessageV2(msg, "please select record", "Info!", 2);
        else
        {
            switch (status)
            {
                case 0:
                    Config.ShowMessageV2(msg, "selected records have been marked as featured successfully", "Success!", 1);
                    break;
                case 1:
                    Config.ShowMessageV2(msg, "selected records have been marked as normal successfully", "Success!", 1);
                    break;
                case 3:
                    Config.ShowMessageV2(msg, "selected records have been marked as premium successfully", "Success!", 1);
                    break;
            }
        }
        BindList();
    }

    protected void drp_pagesize_SelectedIndexChanged(object sender, EventArgs e)
    {
        BindList();
    }

    
   
}
