﻿<%@ WebHandler Language="C#" Class="cats" %>

using System;
using System.Web;
using System.Text;
using System.Collections;
using System.Collections.Generic;

public class cats : IHttpHandler {

    // Ajax version of rec_ph_v2.ascx script
    private string Term = ""; // to load photos based on term
    public int Type = 0; // 0: videos, 1: photos, 2: galleries, 3: blogs
    private int Mode = 0; // group related categories
    private string Order = "added_date desc";
    private int Records = 8;
    private string See_All_Url = "";
    private string See_All_Text = "see all";
    private string See_All_Url_Tooltip = "";
    private int PageNumber = 1;
    private int TotalPages = 0;
    private int TotalColumns = 4;
    public int Width = 130;
    public int Height = 82;
    public string Container = ""; // core container to load all output
    public int isAudio = 0; // 0: video, 1: audio
    public string CategoryLinkCssClass = "big-text bold";
    public bool ShowPreview = true;
    public bool MainCategory = false; // single category listings for every type of contents.
    public int Gallery_Preview_Type = 0; // 0: photo, 1: video album, 2: gallery album
    public void ProcessRequest(HttpContext context)
    {
        context.Response.ContentType = "text/plain";

        if (context.Request.Params["term"] != null)
            this.Term = context.Request.Params["term"].ToString();

        if (context.Request.Params["tp"] != null)
            this.Type = Convert.ToInt32(context.Request.Params["tp"]);

        if (context.Request.Params["gtp"] != null)
            this.Gallery_Preview_Type = Convert.ToInt32(context.Request.Params["gtp"]);

        if (context.Request.Params["isaudio"] != null)
            this.isAudio = Convert.ToInt32(context.Request.Params["isaudio"]);
                  
        if (context.Request.Params["order"] != null)
            this.Order = context.Request.Params["order"].ToString();

        if (context.Request.Params["records"] != null)
            this.Records = Convert.ToInt32(context.Request.Params["records"]);
            

        if (context.Request.Params["pagenumber"] != null)
            this.PageNumber = Convert.ToInt32(context.Request.Params["pagenumber"]);

        if (context.Request.Params["totalpages"] != null)
            this.TotalPages = Convert.ToInt32(context.Request.Params["totalpages"]);

        if (context.Request.Params["tcolumns"] != null)
            this.TotalColumns = Convert.ToInt32(context.Request.Params["tcolumns"]);

        if (context.Request.Params["sallurl"] != null)
            this.See_All_Url = context.Request.Params["sallurl"].ToString();

        if (context.Request.Params["sallt"] != null)
            this.See_All_Text = context.Request.Params["sallt"].ToString();

        if (context.Request.Params["salltool"] != null)
            this.See_All_Url_Tooltip = context.Request.Params["salltool"].ToString();

        if (context.Request.Params["width"] != null)
            this.Width = Convert.ToInt32(context.Request.Params["width"]);

        if (context.Request.Params["height"] != null)
            this.Height = Convert.ToInt32(context.Request.Params["height"]);

        if (context.Request.Params["cnt"] != null)
            this.Container = context.Request.Params["cnt"].ToString();

        if (context.Request.Params["mcat"] != null)
            this.MainCategory = Convert.ToBoolean(context.Request.Params["mcat"]);

        if (context.Request.Params["spreview"] != null)
            this.ShowPreview = Convert.ToBoolean(context.Request.Params["spreview"]);

        if (context.Request.Params["catcss"] != null)
            this.CategoryLinkCssClass = context.Request.Params["catcss"].ToString();
        
        context.Response.Write(BindList());
    }

    public bool IsReusable
    {
        get
        {
            return false;
        }
    }


    private string BindList()
    {
        ArrayList _array = new ArrayList();
        StringBuilder str = new StringBuilder();
        StringBuilder rotator_str = new StringBuilder();
        string contenttype = "video";

        int categorytype = 0; // video categories
        switch (this.Type)
        {
            case 0:
                if (this.isAudio == 1)
                {
                    categorytype = 7; // audio categories
                    contenttype = "audio";
                }
                else
                {
                    categorytype = 0;
                    contenttype = "video";
                }
                break;
            case 1:
                categorytype = 5; // photo categories
                contenttype = "photo";
                break;
            case 2:
                categorytype = 8; // gallery categories
                contenttype = "photo gallery";
                break;
            case 3:
                categorytype = 6; // blog categories;
                contenttype = "blog";
                break;
            case 4:
                categorytype = 1; // group categories;
                contenttype = "Groups";
                break;
        }

        string box_width = "100%";
        switch (this.TotalColumns)
        {
            case 2:
                box_width = "48%";
                break;
            case 3:
                box_width = "32%";
                break;
            case 4:
                box_width = "24%";
                break;
            case 5:
                box_width = "19%";
                break;
        }
        int ctype = categorytype;
        if (categorytype == 8) // gallery and photo has same categories 
            ctype = 5;
        CategoriesBLL.Process_Category_List_Items_Extended(_array, 0, ctype, false, this.Records, this.Mode, this.Order, this.PageNumber);
        if (_array.Count > 0)
        {
            int i = 0;
            int count = 0;
            for (i = 0; i <= _array.Count - 1; i++)
            {

                string category_url = UrlConfig.Prepare_Category_Url(((Category_Struct)_array[i]).ID, ((Category_Struct)_array[i]).Name, "", categorytype, MainCategory);
                str.Append("<div style=\"float:left; width:" + box_width + ";\">");
                str.Append("<div class=\"item_pad_4\">");
                str.Append("<a href=\"" + category_url + "\" class=\"" + CategoryLinkCssClass + "\" title=\"Browse " + contenttype + " in " + ((Category_Struct)_array[i]).Name + "\">" + ((Category_Struct)_array[i]).Name + "</a>");
                str.Append("</div>");
                if (this.ShowPreview)
                {
                    // Fetch latest record for selected category
                    string _term = ((Category_Struct)_array[i]).Term;
                    if (_term == "")
                        _term = ((Category_Struct)_array[i]).Name;
                    // content preview section
                    switch (this.Type)
                    {
                        case 0:
                            // video or audio
                            str.Append(Generate_Video_Preview(_term, rotator_str, contenttype, category_url));
                            break;
                                             

                    }
                }
                    // close content preview section
                    str.Append("</div>");
                    count++;
                    if (count >= this.TotalColumns)
                    {
                        count = 0;
                        str.Append("<div class=\"clear\"></div>");
                    }
                
            }
            str.Append("<div class=\"clear\"></div>"); // clear floating items
            if (this.isAudio == 0 && this.Type == 0)
                str.Append("<script type=\"text/javascript\">" + rotator_str.ToString() + "</script>"); // thumb rotator script
            //***********************************
            // show all link section
            //***********************************
            str.Append("<div class=\"item_pad_4 ui-helper-clearfix\">");
            str.Append("<div style=\"float:left;width:38%;\">\n");
            str.Append("&nbsp;");
            str.Append("</div>\n");
            str.Append("<div style=\"float:left;width:20%; height:30px;\">\n");
            string handler_path = Config.GetUrl("handlers/nav/cats.ashx");
            string parameters = "tp=0&mode=" + this.Mode + "&isaudio=" + this.isAudio + "&order=" + Order + "&records=" + this.Records + "&totalpages=" + this.TotalPages + "&sallurl=" + this.See_All_Url + "&sallt=" + this.See_All_Text + "&salltool=" + this.See_All_Url_Tooltip + "&tcolumns=" + this.TotalColumns + "&width=" + this.Width + "&height=" + this.Height + "&cnt=" + this.Container + "&mcat=" + this.MainCategory + "&catcss=" + this.CategoryLinkCssClass + "&spreview=" + this.ShowPreview + "&gtp=" + Gallery_Preview_Type; 
            string ajax_event = "";
            if (PageNumber > 1)
            {
                // show previous link
                int prev_pagenumber = PageNumber - 1;
                if (prev_pagenumber < 1)
                    prev_pagenumber = 1;
                string prev_parameters = parameters + "&pagenumber=" + prev_pagenumber;

                ajax_event = "Process_Req_Animate('" + handler_path + "','" + prev_parameters + "','#" + this.Container + "','GET','');return false;";
                str.Append("<a href=\"#\" onclick=\"" + ajax_event + "\" title=\"Browse Previous Records\" class=\"btn btn-mini\"><i class=\"icon-arrow-left\"></i></a>&nbsp;");

            }
            if (PageNumber < TotalPages)
            {
                // show next link
                int next_pagenumber = PageNumber + 1;
                if (next_pagenumber > TotalPages)
                    next_pagenumber = TotalPages;
                string next_parameters = parameters + "&pagenumber=" + next_pagenumber;
                ajax_event = "Process_Req_Animate('" + handler_path + "','" + next_parameters + "','#" + this.Container + "','GET','');return false;";

                str.Append("<a href=\"#\" onclick=\"" + ajax_event + "\" title=\"Browse Next Records\" class=\"btn btn-mini\"><i class=\"icon-arrow-right\"></i></a>");
            }
            str.Append("</div>\n");
            str.Append("<div style=\"float:right;width:38%;\">\n");
            str.Append("<div class=\"item_pad_4_r\">\n");
            str.Append("<a href=\"" + Config.GetUrl(this.See_All_Url) + "\" title=\"" + this.See_All_Url_Tooltip + "\">" + this.See_All_Text + "</a>");
            str.Append("</div>\n");
            str.Append("</div>\n");
            str.Append("<div class=\"clear\"></div>\n");
            str.Append("</div>");
            
            //**********************************
            // close show all link section
            //**********************************
        }
        
       return str.ToString();
    
    }
    private string Generate_Video_Preview(string term, StringBuilder rotator_str, string contenttype, string categoryurl)
    {
        StringBuilder str = new StringBuilder();
        VideoItem vd = new VideoItem();
        int records = 6;
        if (this.TotalColumns > 1)
        {
            records = 1;
            vd.ShowTitle = true;
            vd.ShowViews = true;
            vd.Width = this.Width;
            vd.Height = this.Height;
        }
        else
        {
            vd.isHoverEffect = true;
            vd.ShowTitle = false;
            vd.ShowViews = false;
            vd.Width = 80;
            vd.Height = 65;
        }
        // query
        Video_Struct query = new Video_Struct();
        query.Term = term;
        query.isFeatured = 2;
        query.Type = this.isAudio;
        query.UserName = "";
        query.Month = 0;
        query.Year = 0;
        query.Filter = 0;
        query.isEnabled = 1;
        query.isReviewed = 1;
        query.isPrivate = 0;
        query.isAdult = 2;
        query.isExternal = 3;
        query.Order = "date_added desc";
        query.PageSize = records;
        query.SearchType = 0;
        query.DateFilter = 0;
        query.isCache = false;
        query.Mode = 0;
        query.GalleryID = 0;
        query.PageNumber = 1;
        VideoBLL vbll = new VideoBLL();
        List<Video_Struct> _list = vbll.Fetch_Videos_Limit(query);
        if (_list.Count > 0)
        {
            if (this.TotalColumns == 1)
                str.Append("<div class=\"bx_br_both\">\n"); // add top and bottom border for listing
            int i = 0;
            for (i = 0; i <= _list.Count - 1; i++)
            {
                // generate thumb rotator script for single video item      
                if (this.isAudio == 0 && _list[0].Embed_Script == "")
                    rotator_str.Append(UGeneral.Generate_Thumb_Rotator_Script(_list[0].ThumbFileName));

                vd.Type = this.isAudio;
                vd.ShowDate = false;
                vd.ShowAuthor = false;
                vd.ShowDescription = false;
                vd.ShowTags = false;
                vd.ShowCategories = false;
                vd.BoxSpace = 10;

                vd.ContentLayout = 0;
                vd.BoxWidth = 90;
                vd.BoldLinkCssClass = "bold";
                // generate list
                str.Append(vd.Process(_list[i]));
            }
            if (_list.Count >= records && this.TotalColumns == 1)
            {
                str.Append("<div style=\"float:left; padding:65px 0px 0px 10px; width:30px;\">\n");
                str.Append("<a href=\"" + categoryurl + "\" title=\"browse more videos in this category\">more..</a>\n");
                str.Append("</div>\n");
            }
            str.Append("<div class=\"clear\"></div>\n");
            if (this.TotalColumns == 1)
                str.Append("</div>\n"); // close border listing
        }
        return str.ToString();
    }
  
    
}