﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;


public partial class modules_filter_ch : System.Web.UI.UserControl
{
    string _pagename = "Default";
    public string PageName
    {
        get
        {
            return _pagename;
        }
        set
        {
            _pagename = value;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        // Toggle on | off filter
        if (!Config.isFeature_Filter())
        {
            main.Visible = false;
            return;
        }

        if (!Page.IsPostBack)
        {
            if (Request.Params["filter"] != null)
                Set_CSS(Request.Params["filter"].ToString());
            else
                Set_CSS("all");

            Set_Link();
        }
    }

    // set links for filter links
    // type: 0: default, 1: most viewed, 2: most favorited, 3: top rated
    private void Set_Link()
    {
        lnk_alltime.NavigateUrl =  Config.GetUrl("channel/" + this.PageName + ".aspx");
        lnk_thismonth.NavigateUrl =  Config.GetUrl("channel/" + this.PageName + "/ThisMonth.aspx");
        lnk_week.NavigateUrl =  Config.GetUrl("channel/" + this.PageName + "/ThisWeek.aspx");
        lnk_today.NavigateUrl =  Config.GetUrl("channel/" + this.PageName + "/Today.aspx");
    }

    // Set css for active link
    private void Set_CSS(string filter)
    {

        switch (filter)
        {
            case "all":
                lnk_alltime.CssClass = "alt_bld_01";
                break;
            case "ThisMonth":
                lnk_thismonth.CssClass = "alt_bld_01";
                break;
            case "ThisWeek":
                lnk_week.CssClass = "alt_bld_01";
                break;
            case "Today":
                lnk_today.CssClass = "alt_bld_01";
                break;
        }
    }
}
