﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

public partial class modules_tabs_simple : System.Web.UI.UserControl
{
    public string acomplete_clientid; // autocomplete client id
    public string acomplete_serviceurl = ""; // autocomplete service url

    private string _rooturl = "";
    protected void Page_PreRender(object sender, EventArgs e)
    {
        // autocomplete search setup
        acomplete_clientid = txt_search.ClientID;
        acomplete_serviceurl = Config.GetUrl() + "widgets/autocomplete.ashx";

        _rooturl = Config.GetUrl();
        // generate left navigation menus
        Generate_Left_Navigation();

        if(Site_Settings.Feature_Uploads==1)
            Generate_Right_Navigation();

        if (Request.Params["query"] != null)
            txt_search.Text = UtilityBLL.ReplaceHyphinWithSpace(Request.Params["query"].ToString());
    }
   
    // Left Navigation
    private void Generate_Left_Navigation()
    {
        string currenurl = Config.Return_Current_Page();
        StringBuilder str = new StringBuilder();
        str.Append("<ul class=\"nav nav-pills\">\n");
        string videoactive = "";
        string albumactive = "";
        string featuredactive = "";
        string categoriesactive = "";
        string channelactive = "";

        if (currenurl.Contains("/video/") || currenurl.Contains(@"\video\") || currenurl.Contains("/videos/") || currenurl.Contains(@"\videos\"))
            videoactive = " class=\"active\"";
        else if (currenurl.Contains("/albums/") || currenurl.Contains(@"\albums\") || currenurl.Contains("/album/") || currenurl.Contains(@"\album\"))
            albumactive = " class=\"active\"";
        else if (currenurl.Contains("/featured/") || currenurl.Contains(@"\featured\"))
            featuredactive = " class=\"active\"";
        else if (currenurl.Contains("/categories/") || currenurl.Contains(@"\categories\"))
            categoriesactive = " class=\"active\"";
        else if (currenurl.Contains("/channel/") || currenurl.Contains(@"\channel\"))
            channelactive = " class=\"active\"";

        str.Append("<li><a href=\"" + _rooturl + "\">Home</a></li>\n");
        if(Site_Settings.Feature_Videos==1)
        {
            str.Append("<li" + videoactive + "><a href=\"" + _rooturl + "videos/\" title=\"browse all videos\">Videos</a></li>\n");
        }
       
        str.Append("<li" + featuredactive + "><a href=\"" + _rooturl + "featured/\" title=\"browse all featured media\">Featured</a></li>\n");
        str.Append("<li" + categoriesactive + "><a href=\"" + _rooturl + "categories/\" title=\"browse all media categories\">Categories</a></li>\n");
        if (Site_Settings.Feature_Channels == 1)
        {
            str.Append("<li" + channelactive + "><a href=\"" + _rooturl + "channel/\" title=\"browse all user channels\">Channels</a></li>\n");
        }
        str.Append("</ul>\n");

        lsec.InnerHtml = str.ToString();
    }

    private void Generate_Right_Navigation()
    {
        StringBuilder str = new StringBuilder();
        str.Append("<ul class=\"nav nav-pills pull-right\">\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/upload.aspx?tp=1\">Videos</a></li>");
        str.Append("</ul>\n");
        rsec.InnerHtml = str.ToString();
    }

    protected void btn_search_Click1(object sender, EventArgs e)
    {
        if (txt_search.Text != "")
        {
            Response.Redirect(Config.GetUrl("search.aspx?query=" + Server.UrlEncode(UtilityBLL.CleanSearchTerm(txt_search.Text))));
        }
    }
}