﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text;

public partial class videos_archive : System.Web.UI.Page
{
    protected string NavigationClass = "";
    protected string BodyClass = "";
    protected string BodyRight = "";
    protected void Page_Load(object sender, EventArgs e)
    {
        Process_Layout();
        if (!Page.IsPostBack)
        {
            if (archives1 != null)
            {
                archives1.CssClass = "xmedium-text bold"; // set normal link css class
                archives1.ActiveCssClass = "normal-text reverse bold"; // set active css class
                archives1.ListingCssClass = "ver_lstt"; // set listing css class
                archives1.TotalColumns = 3;
                archives1.HeadingTitle = "Video Archives";
                archives1.Type = 0; // 0: videos, 1: groups, 5: photos, 6: blogs, 7: audio files, 8: Galleries, 9: Forums
                archives1.TotalRecords = 6;
                archives1.isAll = true;
            }
           
            // set meta information
            HtmlHead head = (HtmlHead)Page.Header;
            string meta_title = Resources.vsk.videos_archives_title; // "Video Archive List";
            string meta_description = Resources.vsk.videos_archives_desc; // "List of archive links for video. You can browse videos upload via archive month / year.";
            MetaTagsBLL.META_StaticPage(this.Page, head, meta_title, meta_description, UrlConfig.Return_Website_Logo_Url(), Config.GetUrl("videos/archive.aspx"));

            set_bread_links();
        }
    }

    private void set_bread_links()
    {
        string _rooturl = Config.GetUrl();
        StringBuilder str = new StringBuilder();
        str.Append("<li><a href=\"" + _rooturl + "\">" + Resources.vsk.home + "</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/\">Videos</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li class=\"active\">Archive List</li>\n");
        bread.InnerHtml = str.ToString();
    }

    // Core script to handle website layout
    private void Process_Layout()
    {
        UGeneral ug = new UGeneral();
        int selected_layout_option = Site_Settings.NavigationSection;
        if (selected_layout_option == 2)
        {
            // three column layout
            navigation1.Visible = false; // advance navigation disable
            navigation_sm1.Visible = true; // first column simple navigation
            third_nav1.Visible = true; // third column navigation
        }
        else
        {
            // two column layout
            navigation1.Visible = true;
            navigation_sm1.Visible = false;
            third_nav1.Visible = false;

        }

        NavigationClass = ug.Return_Navigation_Class();
        BodyClass = ug.Return_Body_Class();
        BodyRight = ug.Return_RightNav_Class();

    }
}